(*
Copyright  2001-2002 Franois Thomasset, all rights reserved.
Copying is covered by the GNU General Public License (GPL).
 
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.
 
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.
 
$Revision: 1.1.1.1 $
$Date: 2002/03/08 08:31:58 $
*)
(* Quelques utilitaires *)
let rec find_slash_n current_pos s =
  if (current_pos >= (String.length s))
  then raise Not_found
  else
    let pos_slash = String.index_from s current_pos '\\'
    in
    if (pos_slash + 1) = String.length s
    then raise Not_found
    else if (s.[pos_slash+1] = 'n') then pos_slash
    else find_slash_n (pos_slash+2) s ;;

let rec find_double_slash current_pos s =
  if (current_pos >= (String.length s))
  then raise Not_found
  else
    let pos_slash = String.index_from s current_pos '\\'
    in
    if (pos_slash + 1) = String.length s
    then raise Not_found
    else if (s.[pos_slash+1] = '\\') then pos_slash
    else find_double_slash (pos_slash+2) s;;

let remove_double_slash s =
  let ls = String.length s in
  let rec rm_slash2 p new_s =
    if (p >= ls) then new_s
    else
      try
	let psl = find_double_slash p s
	in rm_slash2 (psl+2) (new_s ^ (String.sub s p (psl - p)) ^ "\\")
      with Not_found -> new_s ^ (String.sub s p (ls -p))
  in rm_slash2 0 "";;

let (get_unique_str, reset_unique_str) =
  let c = ref 0
  in
  let f1 () =
    let s = string_of_int (!c)
    in
    c := !c + 1;
    s
  and f2 () = c := 0
  in (f1,f2) ;;

